using MeshVR;using MVR.FileManagementSecure;using SimpleJSON;using System;using System.Collections;using System.Collections.Generic;using System.Linq;using System.Text;using UnityEngine;using UnityEngine.UI;using static UnityEngine.ParticleSystem;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using Random = UnityEngine.Random;using UnityEngine.UI.Extensions;namespace PluginIdea.Fluid{public class SSF : MVRScript{protected bool isResourcesLoaded;protected List<string> audioClipStrs;protected JSONStorableFloat mainAudioVolume, colAudioVolume;protected JSONStorableFloat audiosCount,colAudiosCount;private List<string> audioFiles = new List<string>();protected AudioSource audioSource;public static Dictionary<string, AudioClip> dic_name2Clips = new Dictionary<string, AudioClip>();public static Dictionary<string, GameObject> dic_name2Objects = new Dictionary<string, GameObject>();public static Dictionary<string, Shader> dic_name2Shaders = new Dictionary<string, Shader>();public static Dictionary<string, Cubemap> dic_name2Cubemaps = new Dictionary<string, Cubemap>();public static Dictionary<string, Texture2D> dic_name2Matcaps = new Dictionary<string, Texture2D>();protected GameObject effectObj;private Request request;private Transform RescaleObject{get{return containingAtom.reParentObject.Find("object/rescaleObject");}}protected void LoadResources(string packageName){string assetsBundlePath = $"{Utils.GetPluginPath(this)}/resources/{packageName}{Utils.version}.assetbundle";request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request abffr){AudioClip[] clips = abffr.assetBundle.LoadAllAssets<AudioClip>();for (int i = 0;i < clips.Length;i++){if (!dic_name2Clips.ContainsKey(clips[i].name)){dic_name2Clips.Add(clips[i].name, clips[i]);}}GameObject[] objects = abffr.assetBundle.LoadAllAssets<GameObject>();for (int i = 0;i < objects.Length;i++){if (!dic_name2Objects.ContainsKey(objects[i].name)){dic_name2Objects.Add(objects[i].name, objects[i]);}}Shader[] shaders = abffr.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_name2Shaders.ContainsKey(shaders[i].name)){dic_name2Shaders.Add(shaders[i].name, shaders[i]);}}Cubemap[] cubemaps = abffr.assetBundle.LoadAllAssets<Cubemap>();for (int i = 0;i < cubemaps.Length;i++){if (!dic_name2Cubemaps.ContainsKey(cubemaps[i].name)){dic_name2Cubemaps.Add(cubemaps[i].name, cubemaps[i]);}}Texture2D[] matcaps = abffr.assetBundle.LoadAllAssets<Texture2D>();for (int i = 0;i < matcaps.Length;i++){if (!dic_name2Matcaps.ContainsKey(matcaps[i].name)){dic_name2Matcaps.Add(matcaps[i].name, matcaps[i]);}}isResourcesLoaded = true;ReApplyInit();ReApplyUIParameter();}private bool IsPerson{get{return containingAtom.type == "Person";}}protected void CreateEffectObject(string effectObjName){var prefab = dic_name2Objects[effectObjName];effectObj = GameObject.Instantiate<GameObject>(prefab);if (IsPerson){SuperController.LogError("Please add to the empty atom!");}else{var parent = containingAtom.reParentObject.Find("object/rescaleObject");effectObj.transform.SetParent(parent);effectObj.transform.localPosition = Vector3.zero;effectObj.transform.localScale = Vector3.one;effectObj.transform.localRotation = Quaternion.identity;InitComponents();}if (ccs){}}DAZCharacterSelector myGeometry;DAZCharacterSelector.Gender myGender = DAZCharacterSelector.Gender.None;private bool isMale = false;private void AttachToPerson(){myGeometry = containingAtom.GetStorableByID("geometry") as DAZCharacterSelector;myGender = myGeometry != null ? myGeometry.gender : DAZCharacterSelector.Gender.None;isMale = myGender == DAZCharacterSelector.Gender.Male ? true : false;Rigidbody tmpRB;if (isMale){tmpRB = containingAtom.rigidbodies.First(rb => rb.name == "Gen3");}else{tmpRB = containingAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");}effectObj.transform.SetParent(tmpRB.transform, false);}private Transform rescaleObject;protected void InitComponents(){audioSource = Utils.GetSafeComponent<AudioSource>(effectObj);audioSource.loop = true;RescaleObject.Find("Collider").gameObject.SetActive(false);}protected void SetAudioClip(string val){if (val != "None"){if (dic_name2Clips.ContainsKey(val)){audioSource.clip = dic_name2Clips[val];audioSource.Play();}}else{audioSource.Stop();audioSource.clip = null;}}private const string packageName = "fluid";private const string effectObjName = "Fluid";private List<string> renderCams = new List<string>{"MainCamera", "Window Camera","CaptureCamera"};private List<string> emityShpes = new List<string>{"Cone", "Sphere","Line"};private List<string> beginTypes = new List<string>{"Brook", "Fountain", "Small1", "Small2"};private List<string> attachTypes = new List<string>{"Custom", "Male", "Female"};private List<string> reflectTypes = new List<string>{"CubeMap", "Matcap", "RealTime Grab"};private List<string> texturesSelect = new List<string>();private JSONStorableString A_SprayMultipleTimesCustom;private JSONStorableBool isAutoGranulation;private JSONStorableBool isInteractive;private JSONStorableBool isCastShadow;private JSONStorableStringChooser renderCameras;private JSONStorableStringChooser emitShape;private JSONStorableStringChooser beginType;private JSONStorableStringChooser reflectType;private JSONStorableStringChooser actualReflectTexure;private SSF_Compose composeFluid;private SSF_DepthRenderer fluidRenderer;private ParticleSystem particleSystem;private List<AudioSource> mainAudios, colAudios;private JSONStorableUrl mainUrl,testAudioUrl;private JSONStorableFloat audioVolume;private JSONStorableFloat pScaleXRadio;private JSONStorableFloat pScaleYRadio;private JSONStorableFloat pOffsetY;private JSONStorableFloat pBaseScaleX;private JSONStorableFloat pBaseScaleY;private JSONStorableFloat maxFluidSphereAmount;private JSONStorableFloat emitRate;private JSONStorableFloat sizeMultiper;private JSONStorableFloat shapeRadius;private JSONStorableFloat shapeAngle;private JSONStorableFloat spreadDistance;private JSONStorableFloat arc;private JSONStorableFloat speed;private JSONStorableFloat gravityMul;private JSONStorableFloat shadowStrengh;private JSONStorableFloat lifeTime;private JSONStorableFloat pointScale;private JSONStorableFloat pointScaleBeginMul,pointScaleEndMul,lifeTimeEndSeeker;private JSONStorableFloat thickness;private JSONStorableFloat softness;private JSONStorableFloat stickness;private JSONStorableFloat alpha;private JSONStorableFloat refractStrengh;private JSONStorableFloat refractDistort;private JSONStorableFloat colliderForce;private JSONStorableFloat pointScaleRadius;private JSONStorableFloat collisionScale;private JSONStorableFloat bounceFactor;private JSONStorableFloat collisionLifeTimeLoss;private JSONStorableFloat degreeOfGranularity;private JSONStorableFloat winzoneMultiper;private JSONStorableAction clearAction;private JSONStorableAction startEmitAction;private JSONStorableAction startEmitWithCodeAction;private JSONStorableAction stopEmitAction;private JSONStorableAction generateCubeAction;private JSONStorableColor mainColor;private JSONStorableColor specularColor;private JSONStorableFloat reflection;private JSONStorableFloat reflectionFalloff;private JSONStorableFloat shininess;private JSONStorableBool isCustomLightDir;private JSONStorableFloat lightDirX;private JSONStorableFloat lightDirY;private JSONStorableFloat lightDirZ;private ParticleSystemRenderer renderer;private  ParticleSystem.EmissionModule emissionModule;private  ParticleSystem.MainModule mainModule;private  ParticleSystem.SizeOverLifetimeModule sizeOverTimeModule;private  ParticleSystem.ShapeModule shapeModule;private  ParticleSystem.CollisionModule collisionModule;private ParticleSystem.MinMaxCurve beginMinMaxStartSize;public static RenderTexture m_blurredDepthTexture;public static RenderTexture m_depthTexture;public static RenderTexture m_thicknessTexture;public static RenderTexture m_foamTexture;public static RenderTexture m_blurredDepthTempTexture;private AnimationCurve blurCurve = new AnimationCurve();private AnimationCurve sizeOverTimeCurve = new AnimationCurve();private AnimationCurve sizeOverSpeedCurve = new AnimationCurve();private AnimationCurve vrblurCurve = new AnimationCurve();private ColMono colMono;public override void Init(){Location.InitTData();Utils.InitUI(CreateUIElement);LoadResources(packageName);m_blurredDepthTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_depthTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_thicknessTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_blurredDepthTempTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);audioClipStrs = new List<string>{"None"};UIInit();RegistBundleUnload();blurCurve.AddKey(0.2f, 20);blurCurve.AddKey(0.58f, 8.72f);blurCurve.AddKey(0.75f, 5);blurCurve.AddKey(0.97f, 4f);blurCurve.AddKey(1.235f, 3f);blurCurve.AddKey(1.55f, 2f);blurCurve.AddKey(3.78f, 1f);sizeOverTimeCurve.AddKey(0, 1);sizeOverTimeCurve.AddKey(1, 1);sizeOverSpeedCurve.AddKey(0, 1);sizeOverSpeedCurve.AddKey(1, 1);mainAudios = new List<AudioSource>();colAudios = new List<AudioSource>();SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request != null && request.assetBundle != null){request.assetBundle.Unload(false);}}private bool ccs;private void UIInit(){ccs = Utils.IsCerPass();if (!ccs){Utils.CC2(this);}A_SprayMultipleTimesCustom = new JSONStorableString("Spray X times, customizable", "1,1,100;0.5,0.3,200;0.4,0.4,150", A_SprayMultipleTimesCustomCallback){isStorable = false};RegisterString(A_SprayMultipleTimesCustom);clearAction = Utils.SetupAction(this, "Clear Particle Action", ClearAllParticle);startEmitAction = Utils.SetupAction(this, "StartEmit Action", StartEmit);stopEmitAction = Utils.SetupAction(this, "StopEmit Action", StopEmit);startEmitWithCodeAction = Utils.SetupAction(this, "startEmit With Code Action", () =>{A_SprayMultipleTimesCustomCallback(A_SprayMultipleTimesCustom.val);});Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PluginInfoFluid), 300, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 40, false);renderCameras = Utils.CreateStringChooser(this, Location.GetStr(Location.TargetRenderCamera), renderCams, false, true);renderCameras.setCallbackFunction = SwitchRenderCamera;Utils.CreateSpacer(this, 10, false);Utils.SetupTextInput(this, Location.GetStr(Location.SprayCode), A_SprayMultipleTimesCustom, false);beginType = Utils.CreateStringChooser(this, Location.GetStr(Location.BeginType), beginTypes, false, ccs);beginType.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;switch (val){case "Brook":                        emitShape.val = "Line";sizeMultiper.val = 2;emitRate.val = 1000;bounceFactor.val = 0.16f;speed.val = speed.defaultVal;shapeRadius.val = shapeRadius.defaultVal;shapeAngle.val = shapeAngle.defaultVal;pointScale.val = pointScale.defaultVal;pointScaleEndMul.val = pointScaleEndMul.defaultVal;pointScaleBeginMul.val = pointScaleBeginMul.defaultVal;stickness.val = stickness.defaultVal;arc.val = arc.defaultVal;mainColor.val = mainColor.defaultVal;thickness.val = thickness.defaultVal;break;case "Fountain":                        emitShape.val = emitShape.defaultVal;sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = 0.23f;speed.val = speed.defaultVal;shapeRadius.val = shapeRadius.defaultVal;shapeAngle.val = shapeAngle.defaultVal;pointScale.val = pointScale.defaultVal;pointScaleEndMul.val = pointScaleEndMul.defaultVal;pointScaleBeginMul.val = pointScaleBeginMul.defaultVal;stickness.val = stickness.defaultVal;arc.val = arc.defaultVal;mainColor.val = mainColor.defaultVal;thickness.val = thickness.defaultVal;break;case "Small1":                        emitShape.val = "Cone";sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = bounceFactor.defaultVal;speed.val = 2;shapeRadius.val = 0;shapeAngle.val = 0;pointScale.val = 0.02f;pointScaleBeginMul.val = pointScaleBeginMul.defaultVal;pointScaleEndMul.val = pointScaleEndMul.defaultVal;stickness.val = 0.39f;arc.val = 130;Color mCol = new Color(94 / 255f, 88 / 255f, 43 / 255f);mainColor.SetColor(mCol);thickness.val = thickness.defaultVal;break;case "Small2":                        emitShape.val = "Cone";sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = bounceFactor.defaultVal;speed.val = 0;shapeRadius.val = 0;shapeAngle.val = 0;pointScale.val = 0.01f;pointScaleBeginMul.val = pointScaleBeginMul.defaultVal;pointScaleEndMul.val = pointScaleEndMul.defaultVal;stickness.val = 0.44f;arc.val = arc.defaultVal;Color m2Col = new Color(124 / 255f, 124 / 255f, 124 / 255f);mainColor.SetColor(m2Col);thickness.val = 0.33f;break;default:                        break;}};Utils.CreateSpacer(this, 10, false);Utils.CreateButton(this, Location.GetStr(Location.StartEmit),StartEmit, false, true);Utils.CreateButton(this, Location.GetStr(Location.StartEmitWithCode), () =>{A_SprayMultipleTimesCustomCallback(A_SprayMultipleTimesCustom.val);}, false, true);Utils.CreateButton(this, Location.GetStr(Location.StopEmit), StopEmit, false, true);Utils.CreateButton(this, Location.GetStr(Location.ClearAllParticles), ClearAllParticle, false, true);Utils.CreateSpacer(this, 10, false);Utils.CreateButton(this, Location.GetStr(Location.GrabReflectMap), ()=>{generateCubeAction.actionCallback();}, false, ccs);Utils.CreateSpacer(this, 10, false);Utils.CreateButton(this, Location.GetStr(Location.LoadPreset), LoadPreset, false, ccs);Utils.CreateButton(this, Location.GetStr(Location.SavePreset), SavePreset, false, ccs);winzoneMultiper = Utils.CreateSliderFloat(this, Location.GetStr(Location.WindZoneMul), 1, 0, 10, false, ccs);winzoneMultiper.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;ApplyWindZoneMultiper(val);};maxFluidSphereAmount = Utils.CreateSliderFloat(this, Location.GetStr(Location.MaxFluidSphereAmount), 5000, 1000, 20000, false, ccs);maxFluidSphereAmount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.maxParticles = (int)val;};isAutoGranulation = Utils.CreateToggle(this, Location.GetStr(Location.IsAutoGranulation), true, false, ccs);isAutoGranulation.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;if (ccs)                    Utils.ActiveSliderUI(degreeOfGranularity.slider, !val);});isInteractive = Utils.CreateToggle(this, Location.GetStr(Location.IsShadow), false, false, ccs);isInteractive.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;if (val){isCastShadow.val = false;renderer.enabled = true;renderer.shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.On;renderer.material.color = new Color(0, 0, 0, 0.005f);}else if (!isCastShadow.val){renderer.enabled = false;}if (ccs){Utils.ActiveSliderUI(shadowStrengh.slider, !val);}});isCastShadow = Utils.CreateToggle(this, Location.GetStr(Location.IsCastShadow), true, false, ccs);isCastShadow.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;if (val){isInteractive.val = false;renderer.enabled = true;renderer.shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.ShadowsOnly;shadowStrengh.setCallbackFunction(shadowStrengh.val);}else if (!isInteractive.val){renderer.enabled = false;}if (ccs){Utils.ActiveSliderUI(shadowStrengh.slider, val);}});shadowStrengh = Utils.CreateSliderFloat(this, Location.GetStr(Location.ShadowStrengh), 1f, 0, 1f, false, ccs);shadowStrengh.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;renderer.material.color = new Color(0, 0, 0, val);};degreeOfGranularity = Utils.CreateSliderFloat(this, Location.GetStr(Location.DegreeOfGranularity), 1, 1, 20, false, ccs);degreeOfGranularity.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.blurRadius = (int)val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PhysicsParaSubtitle), 40, false);speed = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleSpeed), 1.5f, 0f, 20, false, true);speed.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.startSpeed = val;};gravityMul = Utils.CreateSliderFloat(this, Location.GetStr(Location.Gravity), 1, 0, 2f, false, ccs);gravityMul.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.gravityModifier = val;};stickness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Stickness), 0.46f, 0, 1, false, ccs);stickness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.dampen = val;};colliderForce = Utils.CreateSliderFloat(this, Location.GetStr(Location.ColliderForce), 0.1f, 0, 50, false, ccs);colliderForce.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.colliderForce = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ParticleSuntitle), 40, false);pointScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.PointScale), 0.03f, 0f, 0.2f, false, true);pointScale.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.startSize = new ParticleSystem.MinMaxCurve(val, val * 3);};pointScaleBeginMul = Utils.CreateSliderFloat(this, Location.GetStr(Location.pointScaleBeginMul), 1f, 0f, 1f, false, ccs);pointScaleBeginMul.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;Utils.UpdateAnimationCurve(sizeOverTimeCurve, 0, val);sizeOverTimeModule.size = new MinMaxCurve(1, sizeOverTimeCurve);};pointScaleEndMul = Utils.CreateSliderFloat(this, Location.GetStr(Location.PointScaleEndMul), 1f, 0f, 1f, false, ccs);pointScaleEndMul.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;Utils.UpdateAnimationCurve(sizeOverTimeCurve, 1, val);sizeOverTimeModule.size = new MinMaxCurve(1, sizeOverTimeCurve);};lifeTimeEndSeeker = Utils.CreateSliderFloat(this, Location.GetStr(Location.PointScaleLifeTimeSeeker), 1f, 0.1f, 1f, false, true);lifeTimeEndSeeker.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;sizeOverTimeCurve.RemoveKey(1);sizeOverTimeCurve.AddKey(val, pointScaleEndMul.val);pointScaleBeginMul.setCallbackFunction(pointScaleBeginMul.val);pointScaleEndMul.setCallbackFunction(pointScaleEndMul.val);};thickness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Thickness), 0.2634f, 0f, 3f, false, ccs);thickness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.thickness = val;};softness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Softness), 1f, 0f, 3f, false, ccs);softness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.softness = val;};bounceFactor = Utils.CreateSliderFloat(this, Location.GetStr(Location.BoundFactor), 0.01f, 0.001f, 1f, false, ccs);bounceFactor.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.bounce = val;};collisionLifeTimeLoss = Utils.CreateSliderFloat(this, Location.GetStr(Location.CollisionLifetimeLoss), 0f, 0, 1f, false, ccs);collisionLifeTimeLoss.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.lifetimeLoss = val;};collisionScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.CollisionScale), 0f, 0, 4f, false, ccs);collisionScale.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.radiusScale = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.MainLookSubTitle), 40, false);reflectType = Utils.CreateStringChooser(this, Location.GetStr(Location.ReflectType), reflectTypes,0, false, ccs);reflectType.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;if (val == "CubeMap"){actualReflectTexure.choices = dic_name2Cubemaps.Keys.ToList();if(string.IsNullOrEmpty(actualReflectTexure.val)) actualReflectTexure.val = actualReflectTexure.choices[0];}else if (val == "Matcap"){actualReflectTexure.choices = dic_name2Matcaps.Keys.ToList();if (string.IsNullOrEmpty(actualReflectTexure.val)) actualReflectTexure.val = actualReflectTexure.choices[0];}else{CreateCubeMap();}};actualReflectTexure = Utils.CreateStringChooser(this, Location.GetStr(Location.ActualReflectTexture), new List<string>(), false, ccs);actualReflectTexure.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;if (reflectType.val == "CubeMap" || reflectType.val == "RealTime Grab"){if (dic_name2Cubemaps.ContainsKey(val))                        composeFluid.m_cubemap = dic_name2Cubemaps[val];else actualReflectTexure.val = actualReflectTexure.choices[0];composeFluid.isMatcap = false;}else if (reflectType.val == "Matcap"){if (dic_name2Matcaps.ContainsKey(val))                        composeFluid.matcap = dic_name2Matcaps[val];else actualReflectTexure.val = actualReflectTexure.choices[0];composeFluid.isMatcap = true;}};Utils.CreateSpacer(this, 10, false);mainColor = Utils.CreateColor(this, Location.GetStr(Location.MainColor), new Color(0.3f, 0.3f, 0.3f), ccs);mainColor.setCallbackFunction = (h, s, v) =>{if (!isResourcesLoaded) return;composeFluid.mainColor = Color.HSVToRGB(h, s, v);};specularColor = Utils.CreateColor(this, Location.GetStr(Location.SpecularColor), new Color(0.9f, 0.9f, 0.9f), ccs);specularColor.setCallbackFunction = (h, s, v) =>{if (!isResourcesLoaded) return;composeFluid.specularColor = Color.HSVToRGB(h, s, v);};alpha = Utils.CreateSliderFloat(this, Location.GetStr(Location.MainAlpha), 1, 0, 1, false, true);alpha.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.alpha = val;};shininess = Utils.CreateSliderFloat(this, Location.GetStr(Location.Shiness), 64, 0, 200, false, ccs);shininess.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.highLight = val;};refractStrengh = Utils.CreateSliderFloat(this, Location.GetStr(Location.RefractStrengh), 1f, 0, 10, false, ccs);refractStrengh.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.refractionStrengh = val;};refractDistort = Utils.CreateSliderFloat(this, Location.GetStr(Location.RefractDistort), 5f, 0, 100, false, ccs);refractDistort.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.refracDistortStrengh = val;};reflection = Utils.CreateSliderFloat(this, Location.GetStr(Location.Reflection), 0.2f, 0, 1, false, ccs);reflection.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.reflectStrengh = val;};Utils.CreateSpacer(this, 10, false);isCustomLightDir = Utils.CreateToggle(this, Location.GetStr(Location.IsCustomLightDir), false, false, ccs);isCustomLightDir.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;composeFluid.customLightDirPara = new Vector4(composeFluid.customLightDirPara.x, composeFluid.customLightDirPara.y, composeFluid.customLightDirPara.z, val ? 1 : 0);if (ccs){Utils.ActiveSliderUI(lightDirX.slider, val);Utils.ActiveSliderUI(lightDirY.slider, val);Utils.ActiveSliderUI(lightDirZ.slider, val);}});lightDirX = Utils.CreateSliderFloat(this, Location.GetStr(Location.lightDirX), 0, -0.5f, 0.5f, false, ccs);lightDirX.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;float w = isCustomLightDir.val ? 1 : 0;composeFluid.customLightDirPara = new Vector4(val, composeFluid.customLightDirPara.y, composeFluid.customLightDirPara.z, w);};lightDirY = Utils.CreateSliderFloat(this, Location.GetStr(Location.lightDirY), 0, -0.5f, 0.5f, false, ccs);lightDirY.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;float w = isCustomLightDir.val ? 1 : 0;composeFluid.customLightDirPara = new Vector4(composeFluid.customLightDirPara.x, val, composeFluid.customLightDirPara.z, w);};lightDirZ = Utils.CreateSliderFloat(this, Location.GetStr(Location.lightDirZ), 1, -0.5f, 0.5f, false, ccs);lightDirZ.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;float w = isCustomLightDir.val ? 1 : 0;composeFluid.customLightDirPara = new Vector4(composeFluid.customLightDirPara.x, composeFluid.customLightDirPara.y, val, w);};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.EmitSubtitle), 40, true);sizeMultiper = Utils.CreateSliderFloat(this, Location.GetStr(Location.SizeMultiper), 1, 0.1f, 10, true, ccs);sizeMultiper.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;if (emitShape.val == "Line") shapeModule.scale = new Vector3(val, 0, 0);else shapeModule.scale = Vector3.one * val;};emitShape = Utils.CreateStringChooser(this, Location.GetStr(Location.EmitShape), emityShpes,0, true, ccs);emitShape.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;switch (val){case "Cone": shapeModule.shapeType = ParticleSystemShapeType.Cone;shapeModule.scale = Vector3.one;break;case "Sphere": shapeModule.shapeType = ParticleSystemShapeType.Sphere;shapeModule.scale = Vector3.one;break;case "Line": shapeModule.shapeType = ParticleSystemShapeType.Box;shapeModule.scale = new Vector3(sizeMultiper.val, 0, 0);break;default:                        break;}};emitRate = Utils.CreateSliderFloat(this, Location.GetStr(Location.EmitRate), 100, 1f, 2000, true, ccs);emitRate.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;emissionModule.rateOverTime = val;};lifeTime = Utils.CreateSliderFloat(this, Location.GetStr(Location.LifeTime), 5, 0f, 50, true, ccs);lifeTime.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.startLifetime = val;};shapeRadius = Utils.CreateSliderFloat(this, Location.GetStr(Location.ShapeRadius), 0f, 0, 2, true, true);shapeRadius.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.radius = val;};spreadDistance = Utils.CreateSliderFloat(this, Location.GetStr(Location.SpreadDistance), 0f, 0, 10, true, ccs);spreadDistance.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.randomPositionAmount = val;};shapeAngle = Utils.CreateSliderFloat(this, Location.GetStr(Location.ShapeAngles), 5, 0, 360, true, ccs);shapeAngle.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.angle = val;};arc = Utils.CreateSliderFloat(this, Location.GetStr(Location.ARC), 5, 0, 360, true, ccs);arc.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.arc = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PartcleShapeSubtitle), 40, false);pScaleXRadio = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleScaleXRadio), 0f, 0, 2f, false, ccs);pScaleXRadio.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.hStrengh = val;};pScaleYRadio = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleScaleYRadio), 0.7f, 0, 2f, false, ccs);pScaleYRadio.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vStrengh = val;};pOffsetY = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleOffsetY), 0.5f, -1f, 1f, false, ccs);pOffsetY.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vOffset = val;};pBaseScaleX = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleBaseScaleXRadio), 1f, 0, 2f, false, ccs);pBaseScaleX.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.hBaseOffset = val;};pBaseScaleY = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleBaseScaleYRadio), 1f, 0, 2f, false, ccs);pBaseScaleY.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vBaseOffset = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.AudioSubtitle), 40, true);mainUrl = Utils.CreateAudioChooser(this, Location.GetStr(Location.MainAudioURL), "", true, (folder) =>{if (!isResourcesLoaded) return;List<string> files = new List<string>();audioFiles.Clear();Utils.GetAllSubFiles(folder, ref files);if (files.Count > 0){files.ForEach(p =>{if (p.EndsWith(".wav") || p.EndsWith(".mp3")){p = p.Replace('\\', '/');audioFiles.Add(p);QueueAudio(p);}});}}, ccs);audiosCount = Utils.CreateSliderInt(this, Location.GetStr(Location.AudioSourceCount), 1, 1, 5, true, ccs);audiosCount.setCallbackFunction = (val) =>{mainAudios.ForEach(x => x.enabled = false);for (int i = 0;i < audiosCount.val;i++){mainAudios[i].enabled = true;}};Utils.CreateButton(this, Location.GetStr(Location.PlayMainAudio), () =>{TestAudio();}, true, ccs);Utils.CreateButton(this, Location.GetStr(Location.StopPlay), StopMainAudio, true, ccs);Utils.CreateButton(this, Location.GetStr(Location.ClearAudioFile), () =>{StopMainAudio();mainUrl.ClearVal();}, true, ccs);mainAudioVolume = Utils.CreateSliderFloat(this, Location.GetStr(Location.AudioVolume), 1f, 0f, 1f, true, ccs);mainAudioVolume.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainAudios.ForEach(x => x.volume = val);};}private void PlayMainAudio(){StopMainAudio();PlayMainAudios();}private void PlayMainAudios(){if (audioFiles.Count > 0){int minCount = Mathf.Min(audioFiles.Count, (int)audiosCount.val);for (int i = 0;i < minCount;i++){NamedAudioClip namedAudioClip = URLAudioClipManager.singleton.GetClip(audioFiles[i]);if (namedAudioClip != null){var clip = namedAudioClip.clipToPlay;mainAudios[i].clip = clip;mainAudios[i].Play();}}}}private void TestAudio(){StopMainAudio();PlayMainAudios();}private void StopMainAudio(){if(mainAudios.Count > 0) mainAudios.ForEach(x => x.Stop());}private void StopColAudio(){if (colAudios.Count > 0) colAudios.ForEach(x => x.Stop());}private Cubemap cubemap;private void CreateCubeMap(){cubemap = Utils.GenerateCubemap(512, containingAtom.mainController.transform.position, containingAtom.mainController.transform.rotation);composeFluid.m_cubemap = cubemap;}private const string presetSavePath = "Saves\\RealFluidSim";private const string presetEndfix = "json";private const string defaultPresetPath = "Saves\\RealFluidSim\\default.json";private void SavePreset(){FileManagerSecure.CreateDirectory(presetSavePath);var fileBrowserUI = SuperController.singleton.fileBrowserUI;fileBrowserUI.SetTitle("Save Fluid Preset");fileBrowserUI.fileRemovePrefix = null;fileBrowserUI.hideExtension = false;fileBrowserUI.keepOpen = false;fileBrowserUI.fileFormat = presetEndfix;fileBrowserUI.defaultPath = presetSavePath;fileBrowserUI.showDirs = true;fileBrowserUI.shortCuts = null;fileBrowserUI.browseVarFilesAsDirectories = false;fileBrowserUI.SetTextEntry(true);fileBrowserUI.Show((path) =>{JSONClass jc = GetSaveJc();if (string.IsNullOrEmpty(path))                    return;if (!path.EndsWith(".json"))                    path += ".json";SuperController.singleton.SaveJSON(jc, path);SuperController.LogMessage("Save Preset Success : " + path);});fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + presetEndfix;fileBrowserUI.ActivateFileNameField();}private void LoadPreset(){var shortcuts = FileManagerSecure.GetShortCutsForDirectory(presetSavePath);SuperController.singleton.GetMediaPathDialog((path) =>{Debug.Log(path);if (string.IsNullOrEmpty(path))                    return;var saveJsonNode = SuperController.singleton.LoadJSON(path);if (saveJsonNode == null) return;SuperController.LogMessage("Load Preset Success: " + path);OnPresetLoadSuccessed(saveJsonNode);}, presetEndfix, presetSavePath, false, true, false, null, false, shortcuts);}private void OnPresetLoadSuccessed(JSONNode obj){if(!string.IsNullOrEmpty(obj["isAutoGranulation"].Value)) isAutoGranulation.val = bool.Parse(obj["isAutoGranulation"].Value);if(!string.IsNullOrEmpty(obj["isCustomLightDir"].Value)) isCustomLightDir.val = bool.Parse(obj["isCustomLightDir"].Value);if (!string.IsNullOrEmpty(obj["isShadow"].Value)) isInteractive.val = bool.Parse(obj["isShadow"].Value);if (!string.IsNullOrEmpty(obj["isCastShadow"].Value)) isCastShadow.val = bool.Parse(obj["isCastShadow"].Value);if (!string.IsNullOrEmpty(obj["degreeOfGranularity"].Value)) degreeOfGranularity.val = float.Parse(obj["degreeOfGranularity"].Value);if (!string.IsNullOrEmpty(obj["emitRate"].Value)) emitRate.val = float.Parse(obj["emitRate"].Value);if (!string.IsNullOrEmpty(obj["arc"].Value)) arc.val = float.Parse(obj["arc"].Value);if (!string.IsNullOrEmpty(obj["shapeRadius"].Value)) shapeRadius.val = float.Parse(obj["shapeRadius"].Value);if (!string.IsNullOrEmpty(obj["shapeAngle"].Value)) shapeAngle.val = float.Parse(obj["shapeAngle"].Value);if (!string.IsNullOrEmpty(obj["bounceFactor"].Value)) bounceFactor.val = float.Parse(obj["bounceFactor"].Value);if (!string.IsNullOrEmpty(obj["speed"].Value)) speed.val = float.Parse(obj["speed"].Value);if (!string.IsNullOrEmpty(obj["gravityMul"].Value)) gravityMul.val = float.Parse(obj["gravityMul"].Value);if (!string.IsNullOrEmpty(obj["lifeTime"].Value)) lifeTime.val = float.Parse(obj["lifeTime"].Value);if (!string.IsNullOrEmpty(obj["pointScale"].Value)) pointScale.val = float.Parse(obj["pointScale"].Value);if (!string.IsNullOrEmpty(obj["pointScaleBeginMul"].Value)) pointScaleBeginMul.val = float.Parse(obj["pointScaleBeginMul"].Value);if (!string.IsNullOrEmpty(obj["pointScaleEndMul"].Value)) pointScaleEndMul.val = float.Parse(obj["pointScaleEndMul"].Value);if (!string.IsNullOrEmpty(obj["stickness"].Value)) stickness.val = float.Parse(obj["stickness"].Value);if (!string.IsNullOrEmpty(obj["colliderForce"].Value)) colliderForce.val = float.Parse(obj["colliderForce"].Value);if (!string.IsNullOrEmpty(obj["alpha"].Value)) alpha.val = float.Parse(obj["alpha"].Value);if (!string.IsNullOrEmpty(obj["winzoneMultiper"].Value)) winzoneMultiper.val = float.Parse(obj["winzoneMultiper"].Value);if (!string.IsNullOrEmpty(obj["refractStrengh"].Value)) refractStrengh.val = float.Parse(obj["refractStrengh"].Value);if (!string.IsNullOrEmpty(obj["collisionScale"].Value)) collisionScale.val = float.Parse(obj["collisionScale"].Value);if (!string.IsNullOrEmpty(obj["thickness"].Value)) thickness.val = float.Parse(obj["thickness"].Value);if (!string.IsNullOrEmpty(obj["reflection"].Value)) reflection.val = float.Parse(obj["reflection"].Value);if (!string.IsNullOrEmpty(obj["softness"].Value)) softness.val = float.Parse(obj["softness"].Value);int oindex = int.Parse(obj["emitShape"].Value);emitShape.val = emityShpes[oindex];if (!string.IsNullOrEmpty(obj["shininess"].Value)) shininess.val = float.Parse(obj["shininess"].Value);if (!string.IsNullOrEmpty(obj["lightDirX"].Value)) lightDirX.val = float.Parse(obj["lightDirX"].Value);if (!string.IsNullOrEmpty(obj["lightDirY"].Value)) lightDirY.val = float.Parse(obj["lightDirY"].Value);if (!string.IsNullOrEmpty(obj["lightDirZ"].Value)) lightDirZ.val = float.Parse(obj["lightDirZ"].Value);if (!string.IsNullOrEmpty(obj["shadowStrengh"].Value)) shadowStrengh.val = float.Parse(obj["shadowStrengh"].Value);if (!string.IsNullOrEmpty(obj["maxFluidSphereAmount"].Value)) maxFluidSphereAmount.val = float.Parse(obj["maxFluidSphereAmount"].Value);if (!string.IsNullOrEmpty(obj["spreadDistance"].Value)) spreadDistance.val = float.Parse(obj["spreadDistance"].Value);if (!string.IsNullOrEmpty(obj["refractDistort"].Value)) refractDistort.val = float.Parse(obj["refractDistort"].Value);if (!string.IsNullOrEmpty(obj["audioVlolume"].Value)) mainAudioVolume.val = float.Parse(obj["audioVlolume"].Value);if (!string.IsNullOrEmpty(obj["audiosCount"].Value)) audiosCount.val = float.Parse(obj["audiosCount"].Value);if (!string.IsNullOrEmpty(obj["mainUrl"].Value)) mainUrl.val = obj["mainUrl"].Value;mainUrl.setCallbackFunction(mainUrl.val);audiosCount.setCallbackFunction(audiosCount.val);if (!string.IsNullOrEmpty(obj["pScaleXRadio"].Value)) pScaleXRadio.val = float.Parse(obj["pScaleXRadio"].Value);if (!string.IsNullOrEmpty(obj["pScaleYRadio"].Value)) pScaleYRadio.val = float.Parse(obj["pScaleYRadio"].Value);if (!string.IsNullOrEmpty(obj["pOffsetY"].Value)) pOffsetY.val = float.Parse(obj["pOffsetY"].Value);if (!string.IsNullOrEmpty(obj["pBaseScaleX"].Value)) pBaseScaleX.val = float.Parse(obj["pBaseScaleX"].Value);if (!string.IsNullOrEmpty(obj["pBaseScaleY"].Value)) pBaseScaleY.val = float.Parse(obj["pBaseScaleY"].Value);float mh = float.Parse(obj["MColorH"].Value);float ms = float.Parse(obj["MColorS"].Value);float mv = float.Parse(obj["MColorV"].Value);mainColor.SetVal(mh, ms, mv);float sh = float.Parse(obj["SColorH"].Value);float ss = float.Parse(obj["SColorS"].Value);float sv = float.Parse(obj["SColorV"].Value);specularColor.SetVal(sh, ss, sv);}private JSONClass GetSaveJc(){JSONClass jc = new JSONClass();jc["isAutoGranulation"] = isAutoGranulation.val.ToString();jc["isCustomLightDir"] = isCustomLightDir.val.ToString();jc["degreeOfGranularity"] = degreeOfGranularity.val.ToString();jc["emitRate"] = emitRate.val.ToString();jc["arc"] = arc.val.ToString();jc["shapeRadius"] = shapeRadius.val.ToString();jc["shapeAngle"] = shapeAngle.val.ToString();jc["bounceFactor"] = bounceFactor.val.ToString();jc["speed"] = speed.val.ToString();jc["gravityMul"] = gravityMul.val.ToString();jc["lifeTime"] = lifeTime.val.ToString();jc["pointScale"] = pointScale.val.ToString("0.00");jc["pointScaleBeginMul"] = pointScaleBeginMul.val.ToString("0.00");jc["pointScaleEndMul"] = pointScaleEndMul.val.ToString("0.00");jc["stickness"] = stickness.val.ToString("0.00");jc["colliderForce"] = colliderForce.val.ToString();jc["alpha"] = alpha.val.ToString();jc["winzoneMultiper"] = winzoneMultiper.val.ToString();jc["refractStrengh"] = refractStrengh.val.ToString("0.00");jc["collisionScale"] = collisionScale.val.ToString("0.00");jc["thickness"] = thickness.val.ToString("0.00");jc["reflection"] = reflection.val.ToString();jc["softness"] = softness.val.ToString("0.00");jc["emitShape"] = (emityShpes.IndexOf(emitShape.val)).ToString();jc["lightDirX"] = lightDirX.val.ToString();jc["lightDirY"] = lightDirY.val.ToString();jc["lightDirZ"] = lightDirZ.val.ToString();jc["shadowStrengh"] = shadowStrengh.val.ToString();jc["shininess"] = shininess.val.ToString();jc["maxFluidSphereAmount"] = maxFluidSphereAmount.val.ToString();jc["spreadDistance"] = spreadDistance.val.ToString();jc["audioVlolume"] = mainAudioVolume.val.ToString();jc["mainUrl"] = mainUrl.val;jc["audiosCount"] = audiosCount.val.ToString();jc["pScaleXRadio"] = pScaleXRadio.val.ToString();jc["pScaleYRadio"] = pScaleYRadio.val.ToString();jc["pOffsetY"] = pOffsetY.val.ToString();jc["pBaseScaleX"] = pBaseScaleX.val.ToString();jc["pBaseScaleY"] = pBaseScaleY.val.ToString();jc["isShadow"] = isInteractive.val.ToString();jc["isCastShadow"] = isCastShadow.val.ToString();jc["refractDistort"] = refractDistort.val.ToString();jc["MColorH"] = mainColor.val.H.ToString("0.00");jc["MColorS"] = mainColor.val.S.ToString("0.00");jc["MColorV"] = mainColor.val.V.ToString("0.00");jc["SColorH"] = specularColor.val.H.ToString("0.00");jc["SColorS"] = specularColor.val.S.ToString("0.00");jc["SColorV"] = specularColor.val.V.ToString("0.00");return jc;}private void QueueAudio(string audioPath){URLAudioClipManager.singleton.QueueClip(audioPath, null, false);}protected void FluidPositionCallback(float val){if (!isResourcesLoaded) return;}private void StopEmit(){particleSystem.Stop();StopMainAudio();StopColAudio();isColAudioActive = false;isColAudioPlay = false;}private void ClearAllParticle(){particleSystem.Clear(true);}private void StartEmit(){particleSystem.Play();PlayMainAudio();isColAudioActive = true;}private float minCalcPointScale = 0.03f;private float colAudioTimer;private void Update(){if (isAutoGranulation.val && fluidRenderer != null){float dis = Vector3.Distance(containingAtom.mainController.transform.position, Utils.CenterCameraTrans.position);float mm = Utils.IsInVR() ? 0.5f : 1f;float pbscale = pointScaleBeginMul.val * pointScale.val;float pescale = pointScaleEndMul.val * pointScale.val;float pscale = (pbscale * lifeTimeEndSeeker.val + pescale * (1 - lifeTimeEndSeeker.val));float pointScaleMul = pscale < minCalcPointScale ? pscale : minCalcPointScale;pointScaleMul *= mm;int b = (int)(blurCurve.Evaluate(dis) * (pointScaleMul / 0.01f));if (b < 1) b = 1;fluidRenderer.blurRadius = b;}}private void OnEnable(){if (composeFluid) composeFluid.enabled = true;}private void OnDisable(){if (composeFluid) composeFluid.enabled = false;}protected void ReApplyInit(){CreateEffectObject(effectObjName);ParticleSystem[] pss = effectObj.GetComponentsInChildren<ParticleSystem>();if (pss.Length > 0){for (int i = 0;i < pss.Length;i++){var ex = pss[i].externalForces;ex.enabled = true;}}particleSystem = effectObj.GetComponent<ParticleSystem>();emissionModule = particleSystem.emission;mainModule = particleSystem.main;sizeOverTimeModule = particleSystem.sizeOverLifetime;shapeModule = particleSystem.shape;collisionModule = particleSystem.collision;beginMinMaxStartSize = mainModule.startSize;StopEmit();renderer = particleSystem.GetComponent<ParticleSystemRenderer>();renderer.enabled = false;int controlLayer = 1 << LayerMask.NameToLayer("ControlColliders");collisionModule.collidesWith = ~controlLayer;collisionModule.maxCollisionShapes = 2000;collisionModule.sendCollisionMessages = true;composeFluid = Utils.GetSafeComponent<SSF_Compose>(Utils.CenterCamera.gameObject);composeFluid.shader = dic_name2Shaders["PI/Compose"];fluidRenderer = Utils.GetSafeComponent<SSF_DepthRenderer>(effectObj);for (int i = 0;i < audiosCount.max;i++){var ts = effectObj.AddComponent<AudioSource>();ts.spatialBlend = 1;ts.loop = true;ts.enabled = i <= (int)audiosCount.val;mainAudios.Add(ts);}colMono = Utils.GetSafeComponent<ColMono>(effectObj);colAudioTrans = new GameObject("ColAudio").transform;}private Transform colAudioTrans;private bool isColAudioPlay;private int takeCount = 5;private List<ParticleCollisionEvent> collisionEvents = new List<ParticleCollisionEvent>();private bool isColAudioActive;private void OnCollisonWithCollider(GameObject other){if (!isColAudioActive) return;int numCollisionEvents = particleSystem.GetCollisionEvents(other, collisionEvents);int skipStep = 1;if (numCollisionEvents > takeCount){skipStep = numCollisionEvents / takeCount;}Vector3 sumPos = Vector3.zero;float sumForce = 0;int sampleCount = 0;for (int i = 0;i < numCollisionEvents;i+= skipStep){Vector3 pos = collisionEvents[i].intersection;float vec = collisionEvents[i].velocity.magnitude;sumPos += pos;sumForce += vec;sampleCount++;}Vector3 centerPos = sumPos / sampleCount;float radio = (sumForce / sampleCount);colAudioTrans.position = centerPos;colAudios.ForEach(x=>x.volume = radio * 10);if (!isColAudioPlay){isColAudioPlay = true;}}private void SwitchRenderCamera(string targetCam){if (!isResourcesLoaded) return;if (composeFluid != null) Destroy(composeFluid);if (targetCam == "MainCamera"){composeFluid = Utils.GetSafeComponent<SSF_Compose>(Utils.CenterCamera.gameObject);}else if (targetCam == "Window Camera"){var tcam = Utils.GetWindowCamera();composeFluid = Utils.GetSafeComponent<SSF_Compose>(tcam.gameObject);}else if (targetCam == "CaptureCamera"){var creenShotCam = SuperController.singleton.screenshotCamera;composeFluid = Utils.GetSafeComponent<SSF_Compose>(creenShotCam.gameObject);}composeFluid.shader = dic_name2Shaders["PI/Compose"];ReApplyUIParameter();}protected void ReApplyUIParameter(){isAutoGranulation.setCallbackFunction(isAutoGranulation.val);degreeOfGranularity.setCallbackFunction(degreeOfGranularity.val);emitRate.setCallbackFunction(emitRate.val);arc.setCallbackFunction(arc.val);shapeRadius.setCallbackFunction(shapeRadius.val);shapeAngle.setCallbackFunction(shapeAngle.val);bounceFactor.setCallbackFunction(bounceFactor.val);collisionLifeTimeLoss.setCallbackFunction(collisionLifeTimeLoss.val);speed.setCallbackFunction(speed.val);gravityMul.setCallbackFunction(gravityMul.val);lifeTime.setCallbackFunction(lifeTime.val);pointScale.setCallbackFunction(pointScale.val);pointScaleBeginMul.setCallbackFunction(pointScaleBeginMul.val);pointScaleEndMul.setCallbackFunction(pointScaleEndMul.val);mainColor.setCallbackFunction(mainColor.val.H, mainColor.val.S, mainColor.val.V);specularColor.setCallbackFunction(specularColor.val.H, specularColor.val.S, specularColor.val.V);stickness.setCallbackFunction(stickness.val);colliderForce.setCallbackFunction(colliderForce.val);alpha.setCallbackFunction(alpha.val);winzoneMultiper.setCallbackFunction(winzoneMultiper.val);refractStrengh.setCallbackFunction(refractStrengh.val);collisionScale.setCallbackFunction(collisionScale.val);thickness.setCallbackFunction(thickness.val);reflection.setCallbackFunction(reflection.val);softness.setCallbackFunction(softness.val);emitShape.setCallbackFunction(emitShape.val);isCustomLightDir.setCallbackFunction(isCustomLightDir.val);lightDirX.setCallbackFunction(lightDirX.val);lightDirY.setCallbackFunction(lightDirY.val);lightDirZ.setCallbackFunction(lightDirZ.val);shininess.setCallbackFunction(shininess.val);maxFluidSphereAmount.setCallbackFunction(maxFluidSphereAmount.val);spreadDistance.setCallbackFunction(spreadDistance.val);mainUrl.setCallbackFunction(mainUrl.val);mainAudioVolume.setCallbackFunction(mainAudioVolume.val);audiosCount.setCallbackFunction(audiosCount.val);pScaleXRadio.setCallbackFunction(pScaleXRadio.val);pScaleYRadio.setCallbackFunction(pScaleYRadio.val);pOffsetY.setCallbackFunction(pOffsetY.val);pBaseScaleX.setCallbackFunction(pBaseScaleX.val);pBaseScaleY.setCallbackFunction(pBaseScaleY.val);shadowStrengh.setCallbackFunction(shadowStrengh.val);isInteractive.setCallbackFunction(isInteractive.val);isCastShadow.setCallbackFunction(isCastShadow.val);refractDistort.setCallbackFunction(refractDistort.val);reflectType.setCallbackFunction(reflectType.val);actualReflectTexure.setCallbackFunction(actualReflectTexure.val);}protected void ApplyWindZoneMultiper(float val){ParticleSystem[] pss = effectObj.GetComponentsInChildren<ParticleSystem>();if (pss.Length > 0){for (int i = 0;i < pss.Length;i++){var ex = pss[i].externalForces;ex.multiplier = val;}}}private void A_SprayMultipleTimesCallback(float numtimes){DoSprayMultipleTimesRandomDuration((int)Mathf.Floor(numtimes));}private void A_SprayMultipleTimesCustomCallback(string customText){DoSprayMultipleTimesCustom(customText);}private void DoSprayMultipleTimesRandomDuration(int numtimes){if (isSprayActive == false){StartCoroutine(SprayMultipleTimesRandomDuration(numtimes));}}private void DoSprayMultipleTimesCustom(string customText){if (isSprayActive == false){StartCoroutine(SprayMultipleTimesCustom(customText));}}private bool isSprayActive = false;private IEnumerator SprayMultipleTimesRandomDuration(int numtimes){isSprayActive = true;int sprayLoops = 0;while (sprayLoops < numtimes){particleSystem.Play();float sprayTime = UnityEngine.Random.Range(0.1f, 1f);yield return new WaitForSeconds(sprayTime);particleSystem.Stop();float pauseTime = UnityEngine.Random.Range(0.2f, 0.4f);yield return new WaitForSeconds(pauseTime);sprayLoops++;}isSprayActive = false;}private IEnumerator SprayMultipleTimesCustom(string customText){isSprayActive = true;string[] seq = customText.Split(';');if (seq.Length > 0){foreach (string seqElement in seq){string[] sprayElem = seqElement.Split(',');if (sprayElem.Length == 3){emitRate.val = float.Parse(sprayElem[2]);particleSystem.Play();yield return new WaitForSeconds(float.Parse(sprayElem[0]));particleSystem.Stop();yield return new WaitForSeconds(float.Parse(sprayElem[1]));}}}isSprayActive = false;}public void OnBindingsListRequested(List<object> bindings){}private void OnDestroy(){if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}ReleaseRT();Destroy(composeFluid);Destroy(fluidRenderer);Destroy(effectObj);Destroy(colAudioTrans.gameObject);mainAudios.Clear();if (audioFiles.Count > 0){audioFiles.ForEach(a =>{var nc = URLAudioClipManager.singleton.GetClip(a);if (nc != null) URLAudioClipManager.singleton.RemoveClip(nc);});colAudios.Clear();}Utils.DestroyUI();SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);}private static void ReleaseRT(){RenderTexture.ReleaseTemporary(m_blurredDepthTexture);RenderTexture.ReleaseTemporary(m_depthTexture);RenderTexture.ReleaseTemporary(m_thicknessTexture);RenderTexture.ReleaseTemporary(m_blurredDepthTempTexture);}}}